
program CONVERT_IBM_ASCII_TO_PLAIN_ASCII;

{  Written by Ron Alcorn.  The source and program is entirely public
   domain.  All I ask if that if you modify it in any way, to send me
   an updated copy of your modifications to:

   ZIP BBS
   (606) 878-9500 between 7 P.M. and 7 A.M. [EST].
   USRobotics Dual Standard 14,400 HST / 9600 V.32

   or

   Ron Alcorn
   147 Foster Heights Rd.
   London, KY  40741

   Also please notify me of any bugs and please send all of your
   suggestions.

   The pupose of this program is to convert any file that contains IBM
   ASCII codes above 127 to standard ASCII equivalents less than 128.
   Why might you need this program?   Many Epson compatible printers
   are unable to print IBM ASCII graphic characters.

}

VAR

        ZIP_In                : Text;
        ZIP_Out               : Text;
        IBM_ASCII             : char;
        Plain_ASCII           : char;
        Read_File_OK          : Boolean;
        Counter               : Integer;
        Marker                : Integer;
        Send_To               : String[80];

procedure Check_Command_Line;

begin
        if ParamCount < 2 then
                begin
                        WriteLn;
                        WriteLn('IBM ASCII To ASCII File Converter 1.0 by Ron Alcorn');
                        WriteLn;
                        WriteLn('Command line format:  CONVERT <oldfilename> <newfilename or /option>');
                        WriteLn;
                        WriteLn('The /P option will re-direct output to the printer & won''t create the new file.');
                        WriteLn('You can use PRN or any other DOS device as the new file name is you wish.');
                        WriteLn;
                        WriteLn('Examples:');
                        WriteLn;
                        WriteLn('CONVERT ZIP-3-4.MAG ZIP-3-4.ASC');
                        WriteLn('CONVERT ZIP-2-5.MAG /P');
                        WriteLn('CONVERT ZIP-1-2.MAG LPT2');
                        WriteLn('CONVERT ZIP-1-2.MAG COM4');
                        WriteLn('CONVERT ZIP-1-2.MAG CON');
                        WriteLn;
                        WriteLn('Mail suggestions and bugs to 147 Foster Heights Rd., London, KY  40741');
                        Halt(1);
                end;
        if ((ParamCount > 1) AND (ParamStr(2) = '/p')) OR
        ((ParamCount > 1) AND (ParamStr(2) = '/P')) then Send_To := 'PRN'
        else Send_To := ParamStr(2);
end;

procedure Check_For_File_Existence;

begin
        Assign(ZIP_In, ParamStr(1));
        {$I-}
        ReSet(ZIP_In);
        {$I+}
        Read_File_OK := (IOResult = 0);
        if not Read_File_OK then
        begin
                WriteLn;
                WriteLn(ParamStr(1),' not found');
                Halt(1);
        end;
end;
procedure Open_New_File;

begin
        Assign(ZIP_Out,Send_To);
        {$I-}
        ReWrite(ZIP_Out);
        {$I+}
        Read_File_OK := (IOResult = 0);
        if not Read_File_OK then
        begin
                WriteLn;
                WriteLn(ParamStr(2),' is an invalid file/path destination');
                Halt(1);
        end;
end;

procedure Do_Conversion;

begin
        while not Eof(ZIP_In) do
        begin
                Read(ZIP_In,IBM_ASCII);
                Plain_ASCII := IBM_ASCII;
                if (Ord(Plain_ASCII) > 126) AND
                   (Ord(Plain_ASCII) < 254) then Plain_ASCII := '*';
                if IBM_ASCII = '' then Plain_ASCII := '=';
                if IBM_ASCII = '' then Plain_ASCII := '=';
                if IBM_ASCII = '' then Plain_ASCII := '-';
                if IBM_ASCII = '' then Plain_ASCII := '|';
                if IBM_ASCII = '' then Plain_ASCII := ':';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                if IBM_ASCII = '' then Plain_ASCII := '+';
                Write(ZIP_Out,Plain_ASCII);
                Counter := Counter + 1;
                if Counter = 2000 then
                begin
                        Marker := Marker + 1;
                        Counter := 0;
                        Write('[2JProcessing screen ',Marker,'...');
                end;
        end;
        Write(ZIP_Out,Chr(12));
end;

BEGIN
        Counter := 0;
        Marker := 0;
        Send_To := '';
        Check_Command_Line;
        Check_For_File_Existence;
        Open_New_File;
        Do_Conversion;
        Close(ZIP_In);
        Close(ZIP_Out);
END.
